Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
1733
3733
3739
3779
8779
8179
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0
bfs 每次的状态有39种,bfs搜索即可 注释内容为路径输出
#include <iostream> #include <stdio.h> #include <cstring> #include <queue> #include <math.h> #include <algorithm> using namespace std; bool isprime(int n) { for (int i = 2; i <= sqrt(1.0*n); i++) { if (n % i == 0) return 0; } return 1; } int b, e; bool v[11000]; struct node { int n; int t; //std::vector<int> v; }pre, now; void bfs() { queue<node>q; memset(v, 0, sizeof(v)); now.n = b; now.t = 0; //now.v.push_back(b); v[b] = 1; q.push(now); while (!q.empty()) { pre = q.front(); q.pop(); if (pre.n == e) { printf("%d ", pre.t); // for (int i = 0; i < pre.v.size(); i++) // printf("%d ", pre.v[i]); return; } int base[4] = {1,10,100,1000}; int a[4], b[4]; a[0] = pre.n%10; a[1] = pre.n/10%10; a[2] = pre.n/100%10; a[3] = pre.n/1000%10; for (int i = 0; i < 4; i++) { for (int j = 0; j <= 9; j++) { if (i == 3 && j == 0) continue; memcpy(b, a, sizeof(a)); b[i] = j; now.n = 0; for (int k = 3; k >= 0; k--) { now.n += b[k]*base[k]; if (isprime(now.n) && !v[now.n]) { v[now.n] = 1; now.t = pre.t+1; // now.v = pre.v; // now.v.push_back(now.n); q.push(now); } } } } } printf("Impossible "); } int main() { //freopen("1.txt", "r", stdin); int T; scanf("%d", &T); while (T--) { scanf("%d%d", &b, &e); bfs(); } return 0; }